﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'=========================================================================================
' Define Workouts Activity module
'=========================================================================================
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim pnlScrollView As Panel
	Dim btnClose, btnAdd, btnHelp As Button
	Dim scvList As ScrollView
	Dim Header As Panel
	Dim Table As Panel
	Dim Line As Panel
	Dim SelectedItems As Map

	' Scroll View globals
	Dim NumberOfColumns, RowHeight, RowHeight_1, rCount As Int
	Type RowCol (Row As Int, Col As Int)
	Dim LineColor  As Int
	Dim ColumnWidth(3) As Int
	Dim ColumnWidth_1(3) As Int
	Dim ColLineWidth, RowLineWidth As Int
	Dim SelectedRow As Int
	Dim SelectedRowColor As Int		: SelectedRowColor=Colors.DarkGray
	Dim CurrSortCol As Int
	Dim CurrSortSeq As Char

	'Table settings
	NumberOfColumns = 3 'will be overwritten when loading from Database
	ColLineWidth = 0dip
	RowLineWidth = 1dip
	RowHeight_1 = 40dip
	RowHeight= RowHeight_1 + RowLineWidth
	LineColor = Colors.Gray
	CurrSortCol = 1
	CurrSortSeq = "D"
	
	Dim HeaderColor(3) As Int
		HeaderColor(0)=Colors.RGB(0,0,0)
		HeaderColor(1)=Colors.RGB(0,0,0)
		HeaderColor(2)=Colors.RGB(0,0,0)
	
	Dim HeaderFontColor(3) As Int
		HeaderFontColor(0)=Colors.RGB(255,165,0)
		HeaderFontColor(1)=Colors.RGB(255,165,0)
		HeaderFontColor(2)=Colors.RGB(255,165,0)
	
	Dim CellColor(3) As Int
		CellColor(0) = Colors.Black
		CellColor(1) = Colors.Black
		CellColor(2) = Colors.Black
	
	Dim FontColor(3) As Int
		FontColor(0) = Colors.White
		FontColor(1) = Colors.White
		FontColor(2) = Colors.White
	
	Dim FontSize(3) As Float
		FontSize(0) = 16
		FontSize(1) = 16
		FontSize(2) = 16
	
	Dim Alignment(3) As Int
		Alignment(0) = Gravity.LEFT 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.
		Alignment(1) = Gravity.CENTER_VERTICAL
		Alignment(2) = Gravity.CENTER_VERTICAL

	' Entry/Edit Dialog vars
	Dim rVal As Int
	Dim lstKeys, lstLabels, lstValues, lstHints As List

	' Other Variables
	Dim SQLStmt, FixedString As String
	Dim Cursor1 As Cursor
	Dim DataErrors As Boolean
	Dim HelpText, EOLChar As String

End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		Main.SQL1.Initialize(File.DirDefaultExternal, "LogMyWorkout.db", False)
	End If

	Activity.LoadLayout("ScrollViewLayout")
	Activity.Title = "Home > Create Workouts"
	pnlScrollView.Visible = True
	
	' Prepare Buttons
	btnAdd.Initialize("btnAdd")
	btnAdd.Text = "Add"
	btnClose.Initialize("btnClose")
	btnClose.Text = "Close"
	btnHelp.Initialize("btnHelp")
	btnHelp.Text = "?"
		
	' Prepare ScrollView 
	scvList.Initialize(0)
	scvList.Panel.Color=Colors.Black
	Table = scvList.Panel
	Table.Color = LineColor
	If Activity.Height > Activity.Width Then
		pnlScrollView.AddView(btnAdd, 0%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnClose, 40%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnHelp, 80%x, 88%y, 20%x, 12%y)
		pnlScrollView.AddView(scvList, 0%x, RowHeight, 100%x, 86%y - RowHeight)
	Else
		pnlScrollView.AddView(btnAdd, 0%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnClose, 40%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnHelp, 80%x, 80%y, 20%x, 20%y)
		pnlScrollView.AddView(scvList, 0%x, RowHeight, 100%x, 78%y - RowHeight)
	End If
	ColumnWidth(0) = ColLineWidth				' hides the first column
	ColumnWidth(1) = scvList.Width * 1			' sets the remaining column to 100% screen width
	For i=0 To NumberOfColumns-1
		ColumnWidth_1(i) = ColumnWidth(i)-ColLineWidth	
	Next
	SelectedRow = -1
	SelectedItems.Initialize
	
	LoadWorkoutsFromDB(CurrSortCol)

	' Initialize Add/Edit parameter lists
	lstKeys.Initialize
	lstLabels.Initialize
	lstValues.Initialize
	lstHints.Initialize
	lstKeys.Add("Header")
	lstLabels.Add("Workout Name")
	lstValues.Add("")
	lstHints.Add("Enter a unique name")
	Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise")
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		lstKeys.Add(Cursor1.GetString("ExID"))
		lstLabels.Add(Cursor1.GetString("Exercise") & " (" & Cursor1.GetString("QtyORMinsPerSet") & ")")
		lstValues.Add("")
		lstHints.Add("Select/Deselect Exercise")
	Next
	Cursor1.Close

	Main.bmpAndroid.Initialize(File.DirAssets, "pullup_48x48.png")
	EOLChar = Chr(13) & Chr(10)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnClose_Click

	Activity.Finish
	StartActivity(Main)

End Sub

Sub btnAdd_Click		' Add new row

	Dim WoTID, NoOfRows, rCount As Int	
	
	lstValues.Clear
	lstValues.Add("")
	Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise")
	NoOfRows = Cursor1.RowCount
	For i = 0 To NoOfRows - 1
		Cursor1.Position = i
		lstValues.Add("0")
	Next
	Cursor1.Close

	' Display Add dialog
	rVal = MuEdit("Add Workout", lstKeys, lstLabels, lstValues, lstHints, 60)

	'*** USE ExecQurySingleResult to Get Last Key ID then add 1 to get new Key ID
	SQLStmt = "SELECT COUNT(*) from WOTemplateH"
	rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
	If rCount > 0 Then
		SQLStmt = "SELECT WoTID from WOTemplateH Order By WoTID Desc"
		WoTID = Main.SQL1.ExecQuerySingleResult(SQLStmt) + 1
	Else
		WoTID = 1
	End If
	
	' Update Database (ADD)
	If rVal = DialogResponse.POSITIVE AND lstValues.Get(0) <> Null Then
		FixedString = xCommon.FixQuotes(lstValues.Get(0))
		SQLStmt = "INSERT INTO WOTemplateH VALUES(" & WoTID & ",'" & FixedString & "')"
		Main.SQL1.ExecNonQuery(SQLStmt)
		For i = 1 To NoOfRows
			If lstValues.Get(i) = "1" Then
				SQLStmt = "INSERT INTO WOTemplateD VALUES('" & WoTID & "', '" & lstKeys.Get(i) & "')"
				Main.SQL1.ExecNonQuery(SQLStmt)
			End If
		Next
		ClearAll
		LoadWorkoutsFromDB(2)
	End If
	
End Sub
Sub Cell_Click			' Edit current row

	Dim rc As RowCol
	Dim l As Label
	Dim DataErrors As Boolean
	Dim NoOfRows As Int
	Dim WoTIDString As String

	l = Sender
	rc = l.Tag
	SelectRow(rc.Row)

	lstValues.Clear
	WoTIDString = GetView(rc.Row, 0).Text
	lstValues.Add(GetView(rc.Row, 1).Text)
	Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise")
	NoOfRows = Cursor1.RowCount
	For i = 0 To NoOfRows - 1
		Cursor1.Position = i
		' Check if exercise is currently selected for this workout
		SQLStmt = "SELECT COUNT(*) FROM WOTemplateD WHERE WoTID = " & WoTIDString & " AND ExID = " & Cursor1.GetString("ExID") 
		If Main.SQL1.ExecQuerySingleResult(SQLStmt) > 0 Then
			lstValues.Add("1")
		Else
			lstValues.Add("0")
		End If
	Next
	Cursor1.Close

	' Display Edit dialog
	rVal = MuEdit("Edit Workout", lstKeys, lstLabels, lstValues, lstHints, 60)
	
	' Update Database (UPDATE)
	If rVal = DialogResponse.POSITIVE Then
		FixedString = xCommon.FixQuotes(lstValues.Get(0))
		SQLStmt = "UPDATE WOTemplateH Set WorkoutName = '" & FixedString & "' WHERE WoTID = " & WoTIDString
		Main.SQL1.ExecNonQuery(SQLStmt)
		SQLStmt = "DELETE from WOTemplateD WHERE WoTID = " & WoTIDString
		Main.SQL1.ExecNonQuery(SQLStmt)
		For i = 1 To NoOfRows
			If lstValues.Get(i) = "1" Then
				SQLStmt = "INSERT INTO WOTemplateD VALUES('" & WoTIDString & "', '" & lstKeys.Get(i) & "')"
				Main.SQL1.ExecNonQuery(SQLStmt)
			End If
		Next
		ClearAll
		LoadWorkoutsFromDB(2)
	End If
	
End Sub

Sub Cell_LongClick		' Delete current row

	Dim rc As RowCol
	Dim l As Label
	
	l = Sender
	rc = l.Tag
	'SelectRow(rc.Row) ' Commnented out...was causing a bug and not needed
	'Activity.Title = "Long Click: " & rc

	' Check if current workout has been logged
	SQLStmt = "SELECT COUNT(*) from WoLogH WHERE WoTID = " & GetView(rc.Row, 0).Text
	rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
	If rCount > 0 Then
	
		' Tell user that they cannot delete whilst log records exist for this workout 
		HelpText = "This workout has log records in the database and cannot be deleted!" & EOLChar & EOLChar
		HelpText = HelpText & "A workout that has log records can only be removed after the database has been cleared. A database clear can be performed by selecting the clear log menu option from the main screen."
		rVal = Msgbox2(HelpText, "Cannot Delete Workout", "OK", "", "", Main.bmpAndroid)
	
	Else

		' Confirm user wnats to delete row
		rVal = Msgbox2("Are you sure you want to delete the current row?", "Delete Workout", "Yes", "No", "", Main.bmpAndroid)

		' Update Database (DELETE)
		If rVal = DialogResponse.POSITIVE Then
			SQLStmt = "DELETE From WOTemplateH WHERE WoTID = " & GetView(rc.Row, 0).Text
			Main.SQL1.ExecNonQuery(SQLStmt)
			SQLStmt = "DELETE From WOTemplateD WHERE WoTID = " & GetView(rc.Row, 0).Text
			Main.SQL1.ExecNonQuery(SQLStmt)
			ClearAll
			LoadWorkoutsFromDB(2)
		End If

	End If

End Sub

Sub Header_Click		' Re-sort Grid

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	'Activity.Title = "Header short-clicked: " & col
	ClearAll
	LoadWorkoutsFromDB(col)

End Sub

Sub Header_LongClick	' Used to display column sensitive help

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	'Activity.Title = "Header long-clicked: " & col

	' Display Help for Column
	Select col
		Case 1 
			HelpText = "This column contains the name of all workouts that have been created." 
			Msgbox2(HelpText, "Help: Workout Name", "OK", "", "", Main.bmpAndroid)
	End Select
	
End Sub

Sub SelectRow(Row As Int)

' single selection
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = CellColor(col)
		Next
	End If
	SelectedRow = Row
	For col = 0 To NumberOfColumns - 1
		GetView(Row, col).Color = SelectedRowColor
	Next

' multi selection
'	If SelectedItems.ContainsKey(Row) Then
'		For col = 0 To NumberOfColumns - 1
'			GetView(Row, Col).Color = CellColor(col)
'		Next
'		SelectedItems.Remove(Row)
'	Else
'		SelectedItems.Put(Row,GetView(Row, Col).Text)
'		For col = 0 To NumberOfColumns - 1
'			GetView(Row, Col).Color = SelectedRowColor
'		Next
'	End If

End Sub

Sub GetView(Row As Int, Col As Int) As Label

	' Returns the label in the specific cell
	Dim l As Label
	If (Row * NumberOfColumns + Col) <= Table.NumberOfViews Then
		l = Table.GetView(Row * NumberOfColumns + Col)
		Return l
	End If
	
End Sub

Sub LoadWorkoutsFromDB(SortCol As Int)

	Dim i As Int

	If SortCol = 2 Then
		CurrSortSeq = "D"
	End If
	
	If CurrSortSeq = "D" Then
		Cursor1 = Main.SQL1.ExecQuery("SELECT WoTID, WorkoutName FROM WOTemplateH ORDER By WorkoutName")
		CurrSortSeq = "A"
	Else
		Cursor1 = Main.SQL1.ExecQuery("SELECT WoTID, WorkoutName FROM WOTemplateH ORDER By WorkoutName Desc")
		CurrSortSeq = "D"
	End If

	Dim row(NumberOfColumns) As String
	row(0)="WoTID"
	If CurrSortSeq = "A" Then
		row(1)="Workout Name  >>"
	Else
		row(1)="Workout Name  <<"
	End If
	SetHeader(row)
	
	For i = 0 To Cursor1.RowCount - 1
		Dim row(NumberOfColumns) As String
		Cursor1.Position = i
		row(0)=Cursor1.GetString("WoTID")
		row(1)=Cursor1.GetString("WorkoutName")
		AddRow(row)
	Next
	Cursor1.Close
	
End Sub
Sub AddRow(Values() As String)

' Adds a row to the table
	Dim ColWidth As Int
	
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	Dim lastRow As Int
	lastRow = NumberOfRows
	ColWidth=0

	For i = 0 To NumberOfColumns - 1
 		Dim l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i)
		l.TextColor = FontColor(i)
		l.Color=CellColor(i)
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = lastRow
		l.Tag = rc
		Table.AddView(l, ColWidth, RowHeight * lastRow, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next

	Table.Height = NumberOfRows * RowHeight + 2
	
End Sub

Sub SetHeader(Values() As String)

	Dim ColWidth As Int

	'If Header.IsInitialized Then Return 'should only be called once
	Header.Initialize("")
	Line.Initialize("")
	Line.Color = Colors.Gray
	ColWidth=0
	Log("Head")
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = Values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i) + 2
		l.Color = HeaderColor(i)
		l.TextColor = HeaderFontColor(i)
		l.Tag = i
		Header.AddView(l, ColWidth, 0, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next
	pnlScrollView.AddView(Header, scvList.Left, scvList.Top - RowHeight, scvList.Width, RowHeight)
	pnlScrollView.AddView(Line, scvList.Left, scvList.Top - 1dip, scvList.Width, 1%y)

End Sub

Sub ClearAll

	' Clears the table
	For i = Table.NumberOfViews -1 To 0 Step -1
		Table.RemoveViewAt(i)
	Next
	Table.Height = 0
	SelectedItems.Clear

End Sub

Sub NumberOfRows As Int

	Return Table.NumberOfViews / NumberOfColumns
	
End Sub

Sub MuEdit(Title As String, Keys As List, Labels As List, Values As List, Hints As List, Labelwidth As Int) As Int

'    Multiple line input dialog. Uses Lib 'Dialogs' by Andrew Graham
'    Dimension of Lists has to be equal or at least that of 'Labels'
'    This SUB is modal. No global variables or additional SUBs are necessary. It will return
'    the original ret value of CustomDialog. Values are changed only if "yes"/"OK" button is pressed.
'    Please adapt the Button Texts of CustomDialog as you need them
'    Use Labelwidth to vary the relation between prompts/labels and EditTexts. 10-90. 50 means equal.

    Dim cd As CustomDialog
    Dim scv As ScrollView
    Dim NumberofItems,i As Int
    Dim lwidth,ewidth As Int
    NumberofItems = Labels.Size
    If Labelwidth<10 Then Labelwidth = 10
    If Labelwidth>90 Then Labelwidth = 90
    scv.Initialize((NumberofItems+2)*40dip + 35dip)
    lwidth = (90%x*Labelwidth/100-6)*1dip
    ewidth = (90%x*(1-Labelwidth/100)-10)*1dip
    scv.Color = Colors.DarkGray
    Dim InLabel(NumberofItems) As Label

	' =================================================
	' Add Labels
	' =================================================
	' First line - Workout Name
    InLabel(i).Initialize(""): InLabel(i).TextSize = 16
    InLabel(i).Gravity=Gravity.CENTER_VERTICAL
	InLabel(i).Text = Labels.Get(i)
    'scv.Panel.AddView(InLabel(i),5dip,2dip,lwidth,60dip)
    scv.Panel.AddView(InLabel(i),5dip,2dip,30%x*1dip,60dip)

	' 1 line for each exercise
	For i=1 To NumberofItems - 1
        InLabel(i).Initialize(""): InLabel(i).TextSize = 16
        InLabel(i).Gravity=Gravity.CENTER_VERTICAL
		InLabel(i).Text = Labels.Get(i)
        scv.Panel.AddView(InLabel(i),5dip,i*40dip+30dip,lwidth,40dip)
    Next

	' =================================================
	' Add TextBox / Check Boxes
	' =================================================

	Dim MuEditInputsET(1)	As EditText 
    Dim MuEditInputsCB(NumberofItems) As CheckBox 

	' First line - Workout Name
	MuEditInputsET(0).Initialize("")
    MuEditInputsET(0).Gravity=Gravity.TOP
    MuEditInputsET(0).Text = Values.Get(0)
    MuEditInputsET(0).Hint = Hints.Get(0): MuEditInputsET(0).HintColor = Colors.LightGray
    scv.Panel.AddView(MuEditInputsET(0),35%x*1dip,2dip,53%x*1dip,60dip)

	' 1 line for each exercise
	For i=1 To NumberofItems - 1
        MuEditInputsCB(i).Initialize("")
        MuEditInputsCB(i).Gravity=Gravity.TOP
        If Values.Get(i) = "1" Then
			MuEditInputsCB(i).Checked = True
		Else
			MuEditInputsCB(i).Checked = False
		End If
        scv.Panel.AddView(MuEditInputsCB(i),lwidth+40dip,i*40dip+30dip,ewidth,40dip)
    Next
	
	' =================================================
	' Display Dialog and receive entered values
	' =================================================
    i=i*50dip + 100dip: If i > 90%y Then i=90%y
    cd.AddView(scv, 0,0,90%x,i) ' sizing relative to the screen size is probably best
	'adapt your button texts as needed here. I do not use the "no" button.
    rVal = cd.Show(Title, "OK", "", "Cancel", Main.bmpAndroid)        
    If rVal = -1 Then     '
		Values.Set(0, MuEditInputsET(0).Text)
        For i=1 To MuEditInputsCB.Length-1
			' Load Check box values into array
			If MuEditInputsCB(i).Checked Then
				Values.Set(i, "1")
			Else
				Values.Set(i, "0")
			End If
        Next
    End If
    Return rVal
    
End Sub

Sub btnHelp_Click		' Form level Help

	HelpText = "Use this screen to view, add, change or delete workouts." & EOLChar & EOLChar
	HelpText = HelpText & "Tasks for this screen:" & EOLChar & EOLChar
	HelpText = HelpText & "- Short press a workout to change the details for that workout." & EOLChar & EOLChar
	HelpText = HelpText & "- Long press a workout to delete the workout." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Add to create a new workout." & EOLChar & EOLChar
	HelpText = HelpText & "- Short Press a column heading to resequence the grid by that column. The sequence will "
	HelpText = HelpText & " toggle between ascending and descending sequence if pressed twice." & EOLChar & EOLChar
	HelpText = HelpText & "- Long Press a column heading to get additional help for that column." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Close to exit the Create Workouts screen and return to the Main screen."

	Msgbox2(HelpText, "Help: Create Workouts", "OK", "", "", Main.bmpAndroid)
	
End Sub
