﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'=========================================================================================
' Log Workouts Activity module
'=========================================================================================
Sub Process_Globals

	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SaveWorkoutText As String
	Dim SaveSetCount(50) As Int
	
End Sub

Sub Globals

	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim pnlScrollView, pnlTable, pnlLine As Panel
	Dim scvTable As ScrollView
	Dim lblDate, lblDateVal, lblWorkout As Label
	Dim lblExercise, lblRepsPerSet, lblSets As Label
	Dim btnClose, btnAdd, btnHelp, btnChgDate, btnWorkout As Button

	' Table variables 
	Dim NoOfRows As Int
	Dim RowHeight, RowLineWidth As Int
	Dim ExerciseID(50) As Int		' An arbitrary number of 50 selected. Don't know at this stage
	Dim RepsPerSet(50) As String	' how many elements there will be and it needs to be global
	Dim SetCount(50) As EditText	' so that EditText can be updated when +/- buttons pressed.
		
	' Other Variables
	Dim WoTID, WoLID, WorkoutDate As Int
	Dim SQLStmt As String
	Dim Cursor1 As Cursor
	Dim HelpText, MsgText, EOLChar As String
	Dim rVal, rCount, i As Int
	Dim lstKeys, lstLabels, lstValues, lstHints As List
	Dim CornerRadius As Float	: CornerRadius = 5

	' Table Settings
	RowHeight = 40dip
	RowLineWidth = 1dip

End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		Main.SQL1.Initialize(File.DirDefaultExternal, "LogMyWorkout.db", False)
		For i = 0 To 49
			SaveSetCount(i) = 1
		Next
	End If

	Activity.LoadLayout("ScrollViewLayout")
	Activity.Title = "Home > Log My Workout"
	pnlScrollView.Visible = True
	
	' Prepare Buttons
	btnAdd.Initialize("btnLog")
	btnAdd.Text = "Log"
	btnClose.Initialize("btnClose")
	btnClose.Text = "Cancel"
	btnHelp.Initialize("btnHelp")
	btnHelp.Text = "?"

	' Prepare Date Selector
	lblDate.Initialize("lblDate")
	lblDate.Text = "Workout Date:"
	lblDate.TextColor = Colors.RGB(255,165,0)
	lblDate.TextSize = 18
	lblDate.Gravity = Gravity.CENTER_VERTICAL
	lblDate.Gravity = Gravity.LEFT
	
	btnChgDate.Initialize("btnChgDate")
	Select Case Main.DateFormat
		Case "DMY"		: DateTime.DateFormat = "dd/MM/yyyy"
		Case "MDY"		: DateTime.DateFormat = "MM/dd/yyyy"
		Case "YMD"		: DateTime.DateFormat = "yyyy/MM/dd"
		Case Else 		: DateTime.DateFormat = "MM/dd/yyyy"
	End Select
	btnChgDate.Text = DateTime.Date(DateTime.Now)
	btnChgDate.TextSize = 16
	WorkoutDate = DateTime.GetYear(DateTime.now) * 10000 + DateTime.GetMonth(DateTime.now) * 100 + DateTime.GetDayOfMonth(DateTime.now)

	' Prepare Workout Selector
	lblWorkout.Initialize("lblWorkout")
	lblWorkout.Text = "Workout:"
	lblWorkout.TextColor = Colors.RGB(255,165,0)
	lblWorkout.TextSize = 18
	lblWorkout.Gravity = Gravity.CENTER_VERTICAL
	lblWorkout.Gravity = Gravity.LEFT

	btnWorkout.Initialize("btnWorkout")
	btnWorkout.Text = "No workout selected"
	btnWorkout.TextSize = 16

	' Prepare Table Header
	lblExercise.Initialize("lblExercise")
	lblExercise.Text = "Exercise"
	lblExercise.TextColor = Colors.RGB(255,165,0)
	lblExercise.TextSize = 18
	lblExercise.Gravity = Gravity.CENTER_VERTICAL
	lblExercise.Gravity = Gravity.LEFT

	lblRepsPerSet.Initialize("lblRepsPerSet")
	lblRepsPerSet.Text = "Reps/Set"
	lblRepsPerSet.TextColor = Colors.RGB(255,165,0)
	lblRepsPerSet.TextSize = 18
	lblRepsPerSet.Gravity = Gravity.CENTER_VERTICAL
	lblRepsPerSet.Gravity = Gravity.LEFT

	lblSets.Initialize("lblSets")
	lblSets.Text = "Sets"
	lblSets.TextColor = Colors.RGB(255,165,0)
	lblSets.TextSize = 18
	lblSets.Gravity = Gravity.CENTER_VERTICAL
	lblSets.Gravity = Gravity.LEFT

	pnlLine.Initialize(0)
	pnlLine.Color = Colors.Gray

	' Prepare ScrollView 
	scvTable.Initialize(0)
	scvTable.Panel.Color=Colors.Green
	pnlTable = scvTable.Panel
	pnlTable.Color = Colors.Gray

	' Initialize Workout Popup parameters
	lstKeys.Initialize
	lstLabels.Initialize
	lstValues.Initialize
	lstHints.Initialize
	Cursor1 = Main.SQL1.ExecQuery("SELECT WoTID, WorkoutName FROM WOTemplateH ORDER By WorkoutName")
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		lstKeys.Add(Cursor1.GetString("WoTID"))
		lstLabels.Add(Cursor1.GetString("WorkoutName"))
		lstValues.Add("")
		lstHints.Add("Select Workout")
	Next
	Cursor1.Close

	' Load Views to Screen
	If Activity.Height > Activity.Width Then
		pnlScrollView.AddView(lblDate,        0%x,  2%y, 40%x, 10%y)
		pnlScrollView.AddView(btnChgDate,    60%x,  2%y, 39%x, 10%y)
		pnlScrollView.AddView(lblWorkout,     0%x, 13%y, 35%x, 10%y)
		pnlScrollView.AddView(btnWorkout,    39%x, 13%y, 60%x, 10%y) 
		pnlScrollView.AddView(lblExercise,    0%x, 24%y, 30%x, 10%y)
		pnlScrollView.AddView(lblRepsPerSet, 40%x, 24%y, 25%x, 10%y)
		pnlScrollView.AddView(lblSets,       79%x, 24%y, 20%x, 10%y)
		pnlScrollView.AddView(pnlLine,        0%x, 31%y, 100%x, 1%y)
		' Scrolview bits
		pnlScrollView.AddView(scvTable,       0%x, 32%y, 100%x, 55%y)
		pnlScrollView.AddView(btnAdd,         0%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnClose,      40%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnHelp,       80%x, 88%y, 20%x, 12%y)
	Else
		pnlScrollView.AddView(lblDate,	      0%x,  3%y, 25%x, 18%y)
		pnlScrollView.AddView(btnChgDate,    26%x,  3%y, 25%x, 18%y)
		'pnlScrollView.AddView(lblWorkout,    0%x, 21%y, 35%x, 18%y)
		pnlScrollView.AddView(btnWorkout,    55%x,  3%y, 40%x, 18%y) 
		pnlScrollView.AddView(lblExercise,    0%x, 23%y, 30%x, 18%y)
		pnlScrollView.AddView(lblRepsPerSet, 40%x, 23%y, 25%x, 18%y)
		pnlScrollView.AddView(lblSets,       79%x, 23%y, 20%x, 18%y)
		pnlScrollView.AddView(pnlLine,        0%x, 36%y, 100%x, 1%y)
		' Scrollview bits
		pnlScrollView.AddView(scvTable,       0%x, 37%y, 100%x, 42%y)
		pnlScrollView.AddView(btnAdd,         0%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnClose,      40%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnHelp,       80%x, 80%y, 20%x, 20%y)
	End If

	Main.bmpAndroid.Initialize(File.DirAssets, "weights_48x48.png")
	EOLChar = Chr(13) & Chr(10)

End Sub

Sub Activity_Resume

	If Main.SaveWoTID <> 0 Then
		WoTID = Main.SaveWoTID
		btnWorkout.Text = SaveWorkoutText
		LoadExercisesForWorkout
	End If

End Sub

Sub Activity_Pause (UserClosed As Boolean)

	Main.SaveWoTID = WoTID
	SaveWorkoutText = btnWorkout.Text

End Sub

Sub btnClose_Click

	WoTID = 0
	For i = 0 To 49
		SaveSetCount(i) = 1
	Next
	Activity.Finish
	StartActivity(Main)

End Sub

Sub btnLog_Click		' Log a workout

	Dim ZeroSets As Boolean
	ZeroSets = Main.PrefManager.GetBoolean("LogZeroSets")
	
	If WoTID <> 0 Then
			
		' Write Workout Log Header
		SQLStmt = "SELECT COUNT(*) from WOLogH"
		rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
		If rCount > 0 Then
			SQLStmt = "SELECT WoLID from WOLogH Order By WoLID Desc"
			WoLID = Main.SQL1.ExecQuerySingleResult(SQLStmt) + 1
		Else
			WoLID = 1
		End If

		'SQLStmt = "INSERT INTO WOLogH VALUES(" & WoLID & ",'" & btnChgDate.Text & "', " & WoTID & ")"
		'SQLStmt = "INSERT INTO WOLogH VALUES(" & WoLID & "," & btnChgDate.Text & ", " & WoTID & ")"
		SQLStmt = "INSERT INTO WOLogH VALUES(" & WoLID & "," & WorkoutDate & ", " & WoTID & ")"
		'Log(SQLStmt)
		Main.SQL1.ExecNonQuery(SQLStmt)

		' Read through Array and write Workout Log records to database
		For i = 0 To 49
			
			If ExerciseID(i) <> 0 Then
				If ZeroSets = True OR (ZeroSets = False AND SetCount(i).Text > 0) Then
					SQLStmt = "INSERT INTO WOLogD VALUES(" & WoLID & ", " & ExerciseID(i) & ", '" & RepsPerSet(i) & "', " & NumberFormat(SetCount(i).Text,1,0) & ")"
					'Log(SQLStmt)
					Main.SQL1.ExecNonQuery(SQLStmt)
				End If
			End If
					
		Next

		WoTID = 0
		For i = 0 To 49
			SaveSetCount(i) = 1
		Next
		Activity.Finish
		StartActivity(Main)

	Else
		MsgText = "A workout must be selected before you press the Log button." & EOLChar & EOLChar
		MsgText = MsgText & "Please select a workout or press the Cancel button to leave this screen."
		Msgbox2(MsgText, "No Workout Selected", "OK", "", "", Main.bmpAndroid)
	End If
		
End Sub
Sub btnChgDate_Click

	' Display Date Select dialog
	Dim dd As DateDialog
	Dim txt As String
	dd.Year = DateTime.GetYear(DateTime.now)
	dd.Month = DateTime.GetMonth(DateTime.now)
	dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.now)
	rVal = dd.Show("Select new date", "Date Selector", "OK", "Cancel", "", Main.bmpAndroid)

	If rVal = -1 Then
		Select Case Main.DateFormat
			Case "MDY"
				btnChgDate.Text = NumberFormat(dd.Month,2,0) & "/" & NumberFormat(dd.DayOfMonth,2,0) & "/" & dd.Year
			Case "DMY"
				btnChgDate.Text = NumberFormat(dd.DayOfMonth,2,0) & "/" & NumberFormat(dd.Month,2,0) & "/" & dd.Year
			Case "YMD"
				btnChgDate.Text = dd.Year & "/" & NumberFormat(dd.Month,2,0) & "/" & NumberFormat(dd.DayOfMonth,2,0)
		End Select 
	End If
	WorkoutDate = dd.Year * 10000 + dd.Month * 100 + dd.DayOfMonth
	'Msgbox("Date as Int: " & WorkoutDate, "Date as Integer")
		
End Sub

Sub btnWorkout_Click

	' Display Select Workout dialog
	rVal = MuEdit("Select Workout", lstKeys, lstLabels, lstValues, lstHints)

	' Clear the table before loading
	For i = pnlTable.NumberOfViews -1 To 0 Step -1
		pnlTable.RemoveViewAt(i)
	Next
	pnlTable.Height = 0
	
	' Load exercises for selected Workout to Table
	If WoTID <> 0 Then
		LoadExercisesForWorkout	
	End If
	
End Sub

Sub LoadExercisesForWorkout

	SQLStmt = "SELECT T2.ExID, T2.Exercise, T2.QtyORMinsPerSet FROM WOTemplateD T1, Exercises T2 WHERE T1.WoTID = " & WoTID & " AND T1.ExID = T2.ExID"

	' Load Exercises 
	Cursor1 = Main.SQL1.ExecQuery(SQLStmt)
	NoOfRows = Cursor1.RowCount
	
	' Clear arrays - THIS DOESN'T WORK!!
	'For i = 0 To 49
	'		RepsPerSet.Text = ""
	'Next i
	'For i = 0 To 49
	'	SetCount(i) = 0
	'Next i
	
	' Load Table
	For i = 0 To NoOfRows - 1

		Cursor1.Position = i
		ExerciseID(i) = Cursor1.GetString("ExID")
		
		Dim L As Label
		L.Initialize("GridRowPanel")
		L.Text = Cursor1.GetString("Exercise")
		L.Tag = "Exercise"
		L.Gravity = Gravity.CENTER_VERTICAL
		L.TextSize = 16
		L.TextColor = Colors.White
		L.Color=Colors.Black
		pnlTable.AddView(L, 0%x, RowLineWidth + i * (RowHeight + RowLineWidth), 100%x, RowHeight)

		Dim L As Label
		L.Initialize("GridRowPanel")
		L.Text = Cursor1.GetString("QtyORMinsPerSet")
		RepsPerSet(i) = L.Text
		L.Tag = "Reps/Set"
		L.Gravity = Gravity.CENTER_VERTICAL
		L.TextSize = 16
		L.TextColor = Colors.White
		L.Color=Colors.Black
		pnlTable.AddView(L, 40%x, RowLineWidth + i * (RowHeight + RowLineWidth), 40%x, RowHeight)
			
		Dim btn As Button
		btn.Initialize("GridRowButtons")
		btn.Tag = NumberFormat(i,1,0)
		btn.Text = "-"
		btn.TextSize = 16
		pnlTable.AddView(btn, 66%x, RowLineWidth + i * (RowHeight + RowLineWidth) + 2dip, 12%x, RowHeight)

		SetCount(i).Initialize("GridRowPanel")
		'SetCount(i).Text = NumberFormat(1,1,0)	' default of 1 set
		SetCount(i).Text = NumberFormat(SaveSetCount(i),1,0)	' Load from save values array
		SetCount(i).InputType = SetCount(i).INPUT_TYPE_NUMBERS
		SetCount(i).Gravity = Gravity.CENTER_VERTICAL
		SetCount(i).Gravity = Gravity.CENTER_HORIZONTAL
		SetCount(i).TextSize = 14
		pnlTable.AddView(SetCount(i), 77%x, RowLineWidth + i * (RowHeight + RowLineWidth) + 2dip, 12%x, RowHeight)

		Dim btn As Button
		btn.Initialize("GridRowButtons")
		btn.Tag = NumberFormat(i,1,0)
		btn.Text = "+"
		btn.TextSize = 16
		pnlTable.AddView(btn, 88%x, RowLineWidth + i * (RowHeight + RowLineWidth) + 2dip, 12%x, RowHeight)

	Next
	Cursor1.Close
	pnlTable.Height = RowLineWidth + 1 + i * (RowHeight + RowLineWidth)

End Sub

Sub GridRowButtons_Click
	
	Dim Send As Button
	Dim Sets, Index As Int
	Dim TagString As String
	Dim PlusMinusPressed As Char	
	
	Send = Sender
	TagString = Send.Tag
	i = TagString
	PlusMinusPressed = Send.Text
	
	Sets = SetCount(i).Text
	If Send.Text = "-" Then
		Sets = Sets - 1
		If Sets < 0 Then
			Sets = 0
		End If
	Else
		Sets = Sets + 1
	End If
	SetCount(i).Text = NumberFormat(Sets,1,0)
	SaveSetCount(i) = Sets
		
End Sub

Sub MuEdit(Title As String, Keys As List, Labels As List, Values As List, Hints As List) As Int

'    Multiple line input dialog. Uses Lib 'Dialogs' by Andrew Graham
'    Dimension of Lists has to be equal or at least that of 'Labels'
'    This SUB is modal. No global variables or additional SUBs are necessary. It will return
'    the original ret value of CustomDialog. Values are changed only if "yes"/"OK" button is pressed.
'    Please adapt the Button Texts of CustomDialog as you need them

    Dim cd As CustomDialog
    Dim scv As ScrollView
    Dim NumberofItems, i As Int
	Dim RowHeight As Int	: RowHeight = 45dip
    NumberofItems = Labels.Size
    scv.Initialize((NumberofItems + 1) * (RowHeight + 4dip))
    scv.Color = Colors.DarkGray
    Dim InLabel(NumberofItems) As Label

	' =================================================
	' Add Labels
	' =================================================
	' 1 line for each workout
	For i=0 To NumberofItems - 1
        InLabel(i).Initialize(""): InLabel(i).TextSize = 16
        InLabel(i).Gravity=Gravity.CENTER_VERTICAL
		InLabel(i).Text = Labels.Get(i)
        scv.Panel.AddView(InLabel(i), 5%x, i* RowHeight, 60%x, RowHeight)
    Next

	' =================================================
	' Add Radio Buttons 
	' =================================================

    Dim MuEditInputsRB(NumberofItems) As RadioButton

	' 1 line for each workout
	For i= 0 To NumberofItems - 1
        MuEditInputsRB(i).Initialize("")
        MuEditInputsRB(i).Gravity=Gravity.CENTER_VERTICAL
        If Values.Get(i) = "1" Then
			MuEditInputsRB(i).Checked = True
		Else
			MuEditInputsRB(i).Checked = False
		End If
        scv.Panel.AddView(MuEditInputsRB(i),70%x , i * RowHeight, 30%x, RowHeight)
    Next
	
	' =================================================
	' Display Dialog and receive entered values
	' =================================================
    i = (i + 1) * RowHeight: If i > 90%y Then i=90%y
    cd.AddView(scv, 0,0,90%x,i) ' sizing relative to the screen size is probably best
    rVal = cd.Show(Title, "OK", "", "Cancel", Main.bmpAndroid)        
    If rVal = -1 Then     '
        For i= 0 To MuEditInputsRB.Length - 1
			' Load Radio Button values into array
			If MuEditInputsRB(i).Checked Then
				Values.Set(i, "1")
				WoTID = Keys.Get(i)
				btnWorkout.Text = Labels.Get(i)
			Else
				Values.Set(i, "0")
			End If
        Next
    End If
    Return rVal
    
End Sub

Sub btnHelp_Click		' Form level Help

	HelpText = "Use this screen to log workout details either after you have completed it, or whilst in progress." & EOLChar & EOLChar
	HelpText = HelpText & "Tasks for this screen:" & EOLChar & EOLChar
	HelpText = HelpText & "- Press the date button to change the workout date." & EOLChar & EOLChar
	HelpText = HelpText & "- Press the workout button to select the workout you wish to log." & EOLChar & EOLChar
	HelpText = HelpText & "- Use the Plus or Minus buttons next to each exercise to increment or "
	HelpText = HelpText & "decrement the number of sets performed for that exercise." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Log to record the workout details." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Cancel to exit the Log My Workout screen without recording the workout and return to the Main screen."

	Msgbox2(HelpText, "Help: Log My Workout", "OK", "", "", Main.bmpAndroid)
	
End Sub
