﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'=========================================================================================
' Setup Exercises Activity module
'=========================================================================================
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim pnlScrollView As Panel
	Dim btnClose, btnAdd, btnHelp As Button
	Dim scvList As ScrollView
	Dim Header As Panel
	Dim Table As Panel
	Dim Line As Panel
	Dim SelectedItems As Map

	' Scroll View globals
	Dim NumberOfColumns, RowHeight, RowHeight_1, rCount As Int
	Type RowCol (Row As Int, Col As Int)
	Dim LineColor  As Int
	Dim ColumnWidth(3) As Int
	Dim ColumnWidth_1(3) As Int
	Dim ColLineWidth, RowLineWidth As Int
	Dim SelectedRow As Int
	Dim SelectedRowColor As Int		: SelectedRowColor=Colors.DarkGray
	Dim CurrSortCol As Int
	Dim CurrSortSeq As Char

	'Table settings
	NumberOfColumns = 3 'will be overwritten when loading from Database
	ColLineWidth = 0dip
	RowLineWidth = 1dip
	RowHeight_1 = 40dip
	RowHeight= RowHeight_1 + RowLineWidth
	LineColor = Colors.Gray
	CurrSortCol = 1
	CurrSortSeq = "D"
	
	Dim HeaderColor(3) As Int
		HeaderColor(0)=Colors.RGB(0,0,0)
		HeaderColor(1)=Colors.RGB(0,0,0)
		HeaderColor(2)=Colors.RGB(0,0,0)
	
	Dim HeaderFontColor(3) As Int
		HeaderFontColor(0)=Colors.RGB(255,165,0)
		HeaderFontColor(1)=Colors.RGB(255,165,0)
		HeaderFontColor(2)=Colors.RGB(255,165,0)
	
	Dim CellColor(3) As Int
		CellColor(0) = Colors.Black
		CellColor(1) = Colors.Black
		CellColor(2) = Colors.Black
	
	Dim FontColor(3) As Int
		FontColor(0) = Colors.White
		FontColor(1) = Colors.White
		FontColor(2) = Colors.White
	
	Dim FontSize(3) As Float
		FontSize(0) = 16
		FontSize(1) = 16
		FontSize(2) = 16
	
	Dim Alignment(3) As Int
		Alignment(0) = Gravity.LEFT 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.
		Alignment(1) = Gravity.CENTER_VERTICAL
		Alignment(2) = Gravity.CENTER_VERTICAL

	' Entry/Edit Dialog vars
	Dim rVal As Int
	Dim lstLabels, lstValues, lstHints As List

	' Other Variables
	Dim SQLStmt, FixedString As String
	Dim Cursor1 As Cursor
	Dim DataErrors As Boolean
	Dim HelpText, EOLChar As String

End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		Main.SQL1.Initialize(File.DirDefaultExternal, "LogMyWorkout.db", False)
	End If

	Activity.LoadLayout("ScrollViewLayout")
	Activity.Title = "Home > Setup Exercises"
	pnlScrollView.Visible = True
	
	' Prepare Buttons
	btnAdd.Initialize("btnAdd")
	btnAdd.Text = "Add"
	btnClose.Initialize("btnClose")
	btnClose.Text = "Close"
	btnHelp.Initialize("btnHelp")
	btnHelp.Text = "?"
		
	' Prepare ScrollView 
	scvList.Initialize(0)
	scvList.Panel.Color=Colors.Black
	Table = scvList.Panel
	Table.Color = LineColor
	If Activity.Height > Activity.Width Then
		pnlScrollView.AddView(btnAdd, 0%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnClose, 40%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnHelp, 80%x, 88%y, 20%x, 12%y)
		pnlScrollView.AddView(scvList, 0%x, RowHeight, 100%x, 86%y - RowHeight)
	Else
		pnlScrollView.AddView(btnAdd, 0%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnClose, 40%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnHelp, 80%x, 80%y, 20%x, 20%y)
		pnlScrollView.AddView(scvList, 0%x, RowHeight, 100%x, 78%y - RowHeight)
	End If
	ColumnWidth(0) = ColLineWidth				' hides the first column
	ColumnWidth(1) = scvList.Width * .50		' sets the remaining column widths 1/2 screen width
	ColumnWidth(2) = scvList.Width * .50
	For i=0 To NumberOfColumns-1
		ColumnWidth_1(i) = ColumnWidth(i)-ColLineWidth	
	Next
	SelectedRow = -1
	SelectedItems.Initialize
	
	LoadExercisesFromDB(CurrSortCol)

	' Initialize Add/Edit parameter lists
	lstLabels.Initialize
	lstLabels.Add("Exercise Name")
	lstLabels.Add("Qty per Set")
	lstValues.Initialize
	lstValues.Add("")
	lstValues.Add("")
	lstHints.Initialize
	lstHints.Add("Enter a unique name")
	lstHints.Add("Default reps for this exercise.")

	Main.bmpAndroid.Initialize(File.DirAssets, "situp_48x48.png")
	EOLChar = Chr(13) & Chr(10)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnClose_Click

	Activity.Finish
	StartActivity(Main)

End Sub

Sub btnAdd_Click		' Add new row

	Dim ExID As Int
	Dim NewString As String
	
	lstValues.Clear
	lstValues.Add("")
	lstValues.Add("")

	' Display Add dialog
	DataErrors = True
	Do While DataErrors
		rVal = MuEdit("Add Exercise", lstLabels, lstValues, lstHints, 30)
		' Check No. of Exercises per Rep is numeric
		'If IsNumber(lstValues.Get(1)) = False AND rVal = DialogResponse.POSITIVE Then
		'	Msgbox("Exercises per Rep must be a numeric value!","Data Entry Error")
		'Else
			DataErrors = False
		'End If
	Loop 

	'*** USE ExecQurySingleResult to Get Last Key ID then add 1 to get new Key ID
	SQLStmt = "SELECT COUNT(*) from Exercises"
		rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
	If rCount > 0 Then
		SQLStmt = "SELECT ExID from Exercises Order By ExID Desc"
		ExID = Main.SQL1.ExecQuerySingleResult(SQLStmt) + 1
	Else
		ExID = 1
	End If
	
	FixedString = xCommon.FixQuotes(lstValues.Get(0))
	
	' Update Database (ADD)
	If rVal = DialogResponse.POSITIVE Then
		SQLStmt = "INSERT INTO Exercises VALUES(" & ExID & ",'" & FixedString & "', '" & lstValues.Get(1) & "')"
		Main.SQL1.ExecNonQuery(SQLStmt)
		ClearAll
		CurrSortCol = 2
		LoadExercisesFromDB(1)
	End If
	
End Sub
Sub Cell_Click			' Edit current row

	Dim rc As RowCol
	Dim l As Label
	Dim DataErrors As Boolean

	l = Sender
	rc = l.Tag
	SelectRow(rc.Row)
	'Activity.Title = "Short Click: " & rc

	lstValues.Clear
	lstValues.Add(GetView(rc.Row, 1).Text)
	lstValues.Add(GetView(rc.Row, 2).Text)

	' Display Edit dialog
	DataErrors = True
	Do While DataErrors
		rVal = MuEdit("Edit Exercise", lstLabels, lstValues, lstHints, 30)
		' Check No. of Exercises per Rep is numeric
		'If IsNumber(lstValues.Get(1)) = False AND rVal = DialogResponse.POSITIVE Then
		'	Msgbox("Exercises per Rep must be a numeric value!","Data Entry Error")
		'Else
			DataErrors = False
		'End If
	Loop 
	
	' Update Database (UPDATE)
	FixedString = xCommon.FixQuotes(lstValues.Get(0))
	If rVal = DialogResponse.POSITIVE Then
		SQLStmt = "UPDATE Exercises Set Exercise = '" & FixedString & "', QtyORMinsPerSet = '" & lstValues.Get(1) & "' WHERE ExID = " & GetView(rc.Row, 0).Text
		Main.SQL1.ExecNonQuery(SQLStmt)
		ClearAll
		CurrSortCol = 2
		LoadExercisesFromDB(1)
	End If
	
End Sub

Sub Cell_LongClick		' Delete current row

	Dim rc As RowCol
	Dim l As Label
	
	l = Sender
	rc = l.Tag
	'SelectRow(rc.Row)' Commnented out...was causing a bug and not needed
	'Activity.Title = "Long Click: " & rc

	' Check if current exercise exists in a workout
	SQLStmt = "SELECT COUNT(*) from WoTemplateD WHERE ExID = " & GetView(rc.Row, 0).Text
	rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
	If rCount > 0 Then
	
		' Tell user that they cannot delete whilst the exercise belongs to a workout
		HelpText = "This exercise exists in a current workout!" & EOLChar & EOLChar
		HelpText = HelpText & "Please remove the exercise from all workouts before attempting to delete it."
		rVal = Msgbox2(HelpText, "Cannot Delete Exercise", "OK", "", "", Main.bmpAndroid)
	
	Else
		' Confirm user wants to delete row
		rVal = Msgbox2("Are you sure you want to delete the current row?", "Delete Exercise", "Yes", "No", "", Main.bmpAndroid)

		' Update Database (DELETE)
		If rVal = DialogResponse.POSITIVE Then
			SQLStmt = "DELETE From Exercises WHERE ExID = " & GetView(rc.Row, 0).Text
			Main.SQL1.ExecNonQuery(SQLStmt)
			ClearAll
			CurrSortCol = 2
			LoadExercisesFromDB(1)
		End If

	End If
	
End Sub

Sub Header_Click		' Re-sort Grid

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	ClearAll
	LoadExercisesFromDB(col)

End Sub

Sub Header_LongClick	' Used to display column sensitive help

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	'Activity.Title = "Header long-clicked: " & col

	' Display Help for Column
	Select col
		Case 1 
			HelpText = "This column contains the name of all exercises that have been created." 
			Msgbox2(HelpText, "Help: Exercise Name", "OK", "", "", Main.bmpAndroid)
		Case 2 
			HelpText = "This column contains either the number of reps or the number of minutes that should be completed for each 'set' of the selected exercise."
			HelpText = HelpText & EOLChar & EOLChar & "e.g. '10 reps', '2 mins'." 
			Msgbox2(HelpText, "Help: Qty/Mins per Set", "OK", "", "", Main.bmpAndroid)
	End Select
	
End Sub

Sub SelectRow(Row As Int)

' single selection
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = CellColor(col)
		Next
	End If
	SelectedRow = Row
	For col = 0 To NumberOfColumns - 1
		GetView(Row, col).Color = SelectedRowColor
	Next

End Sub

Sub GetView(Row As Int, Col As Int) As Label

' Returns the label in the specific cell
	Dim l As Label
	If (Row * NumberOfColumns + Col) <= Table.NumberOfViews Then
		l = Table.GetView(Row * NumberOfColumns + Col)
		Return l
	End If
	
End Sub

Sub LoadExercisesFromDB(SortCol As Int)

	Dim i As Int

	If SortCol = 1 Then
		If CurrSortCol = 1 Then
			If CurrSortSeq = "D" Then
				Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise")
				CurrSortSeq = "A"
			Else
				Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise Desc")
				CurrSortSeq = "D"
			End If
		Else
			Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By Exercise")
			CurrSortCol = 2
			CurrSortSeq = "A"
		End If
	Else
		If CurrSortCol = 2 Then
			If CurrSortSeq = "D" Then
				Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By QtyORMinsPerSet")
				CurrSortSeq = "A"
			Else
				Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By QtyORMinsPerSet Desc")
				CurrSortSeq = "D"
			End If
		Else
			Cursor1 = Main.SQL1.ExecQuery("SELECT ExID, Exercise, QtyORMinsPerSet FROM Exercises ORDER By QtyORMinsPerSet")
			CurrSortCol = 1
			CurrSortSeq = "A"
		End If
	End If 
	CurrSortCol = SortCol

	Dim row(NumberOfColumns) As String
	row(0)="ExID"
	If SortCol = 1 Then
		If CurrSortSeq = "A" Then
			row(1)="Exercise  >>"
		Else
			row(1)="Exercise  <<"
		End If
		row(2)="Qty/Mins / Set"
	Else
		row(1)="Exercise"
		If CurrSortSeq = "A" Then
			row(2)="Qty/Mins / Set  >>"
		Else
			row(2)="Qty/Mins / Set  <<"
		End If
	End If
	SetHeader(row)
	
	For i = 0 To Cursor1.RowCount - 1
		Dim row(NumberOfColumns) As String
		Cursor1.Position = i
		row(0)=Cursor1.GetString("ExID")
		row(1)=Cursor1.GetString("Exercise")
		row(2)=Cursor1.GetString("QtyORMinsPerSet")
		AddRow(row)
	Next
	Cursor1.Close
	
End Sub
Sub AddRow(Values() As String)

' Adds a row to the table
	Dim ColWidth As Int
	
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	Dim lastRow As Int
	lastRow = NumberOfRows
	ColWidth=0

	For i = 0 To NumberOfColumns - 1
 		Dim l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i)
		l.TextColor = FontColor(i)
		l.Color=CellColor(i)
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = lastRow
		l.Tag = rc
		Table.AddView(l, ColWidth, RowHeight * lastRow, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next

	Table.Height = NumberOfRows * RowHeight + 2
	
End Sub

Sub SetHeader(Values() As String)

	Dim ColWidth As Int

	'If Header.IsInitialized Then Return 'should only be called once
	Header.Initialize("")
	Line.Initialize("")
	Line.Color = Colors.Gray
	ColWidth=0
	Log("Head")
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = Values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i) + 2
		l.Color = HeaderColor(i)
		l.TextColor = HeaderFontColor(i)
		l.Tag = i
		Header.AddView(l, ColWidth, 0, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next
	pnlScrollView.AddView(Header, scvList.Left, scvList.Top - RowHeight, scvList.Width, RowHeight)
	pnlScrollView.AddView(Line, scvList.Left, scvList.Top - 1dip, scvList.Width, 1%y)
	
End Sub

Sub ClearAll

	' Clears the table
	For i = Table.NumberOfViews -1 To 0 Step -1
		Table.RemoveViewAt(i)
	Next
	Table.Height = 0
	SelectedItems.Clear

End Sub

Sub NumberOfRows As Int

	Return Table.NumberOfViews / NumberOfColumns
	
End Sub

Sub MuEdit(Title As String, Labels As List, Values As List, Hints As List, Labelwidth As Int) As Int

'    Multiple line input dialog. Uses Lib 'Dialogs' by Andrew Graham
'    Dimension of Lists has to be equal or at least that of 'Labels'
'    This SUB is modal. No global variables or additional SUBs are necessary. It will return
'    the original ret value of CustomDialog. Values are changed only if "yes"/"OK" button is pressed.
'    Please adapt the Button Texts of CustomDialog as you need them
'    Use Labelwidth to vary the relation between prompts/labels and EditTexts. 10-90. 50 means equal.

    Dim cd As CustomDialog
    Dim scv As ScrollView
    Dim NumberofItems,i As Int
    Dim lwidth,ewidth As Int
    NumberofItems = Labels.Size
    If Labelwidth<10 Then Labelwidth = 10
    If Labelwidth>90 Then Labelwidth = 90
    scv.Initialize((NumberofItems+2)*50dip)
    lwidth = (90%x*Labelwidth/100-6)*1dip
    ewidth = (90%x*(1-Labelwidth/100)-10)*1dip
    scv.Color = Colors.DarkGray
    Dim InLabel(NumberofItems) As Label
    For i=0 To NumberofItems-1
        InLabel(i).Initialize(""): InLabel(i).TextSize = 16
        InLabel(i).Gravity=Gravity.CENTER_VERTICAL
        InLabel(i).Text = Labels.Get(i)
        scv.Panel.AddView(InLabel(i),5dip,i*50dip,lwidth,46dip)
    Next
    Dim MuEditInputs(NumberofItems) As EditText 
    For i=0 To NumberofItems-1
        MuEditInputs(i).Initialize("")
        MuEditInputs(i).Text = Values.Get(i)
        MuEditInputs(i).Hint = Hints.Get(i): MuEditInputs(i).HintColor = Colors.LightGray
        scv.Panel.AddView(MuEditInputs(i),lwidth+10dip,i*50dip+2dip,ewidth,50dip)
    Next
    i=i*50dip: If i > 90%y Then i=90%y
    cd.AddView(scv, 0,0,90%x,i) ' sizing relative to the screen size is probably best
	'adapt your button texts as needed here. I do not use the "no" button.
    rVal = cd.Show(Title, "OK", "", "Cancel", Main.bmpAndroid)        
    If rVal = -1 Then     '
        For i=0 To MuEditInputs.Length-1
            Values.Set(i, MuEditInputs(i).Text)
        Next
    End If
    Return rVal
    
End Sub

Sub btnHelp_Click		' Form level Help

	HelpText = "Use this screen to view, add, change or delete the list of exercises that can be added to a workout." & EOLChar & EOLChar
	HelpText = HelpText & "Tasks for this screen:" & EOLChar & EOLChar
	HelpText = HelpText & "- Short press an exercise to change the details for that exercise." & EOLChar & EOLChar
	HelpText = HelpText & "- Long press an exercise to delete the exercise." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Add to create a new exercise." & EOLChar & EOLChar
	HelpText = HelpText & "- Short Press a column heading to resequence the grid by that column. The sequence will "
	HelpText = HelpText & " toggle between ascending and descending sequence if pressed twice." & EOLChar & EOLChar
	HelpText = HelpText & "- Long Press a column heading to get additional help for that column." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Close to exit the Setup Exercises screen and return to the Main screen."

	Msgbox2(HelpText, "Help: Setup Exercises", "OK", "", "", Main.bmpAndroid)
	
End Sub
