﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'=========================================================================================
' View Workouts Activity module
'=========================================================================================
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim pnlScrollView As Panel
	Dim btnClose, btnExport, btnHelp As Button
	Dim scvList As ScrollView
	Dim Header As Panel
	Dim Table As Panel
	Dim Line As Panel
	Dim SelectedItems As Map

	' Scroll View globals
	Dim NumberOfColumns, RowHeight, RowHeight_1 As Int
	Type RowCol (Row As Int, Col As Int)
	Dim LineColor  As Int
	Dim ColumnWidth(5) As Int
	Dim ColumnWidth_1(5) As Int
	Dim ColLineWidth, RowLineWidth As Int
	Dim SelectedRow As Int
	Dim SelectedRowColor As Int		: SelectedRowColor=Colors.DarkGray
	Dim CurrSortSeq As Char
	Dim CurrSortCol As Int
	
	'Table settings
	NumberOfColumns = 5 'will be overwritten when loading from Database
	' Column 1 - Workout Log ID
	' Column 2 - Workout Date
	' Column 3 - Workout Name
	' Column 4 - Selection Expanded/Collapsed flag
	' Column 5 - Number of child nodes added
	ColLineWidth = 0dip
	RowLineWidth = 1dip
	RowHeight_1 = 40dip
	RowHeight= RowHeight_1 + RowLineWidth
	LineColor = Colors.Gray
	CurrSortCol = 1
	CurrSortSeq = "D"

	' Entry/Edit Dialog vars
	Dim rVal As Int

	' Other Variables
	Dim SQLStmt As String
	Dim Cursor1 As Cursor
	Dim DataErrors As Boolean
	Dim HelpText, MsgText, EOLChar As String

End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		Main.SQL1.Initialize(File.DirDefaultExternal, "LogMyWorkout.db", False)
	End If

	Activity.LoadLayout("ScrollViewLayout")
	Activity.Title = "Home > View Workouts"
	pnlScrollView.Visible = True
	
	' Prepare Buttons
	btnExport.Initialize("btnExport")
	btnExport.Text = "Export"
	btnClose.Initialize("btnClose")
	btnClose.Text = "Close"
	btnHelp.Initialize("btnHelp")
	btnHelp.Text = "?"
		
	' Prepare ScrollView 
	scvList.Initialize(0)
	scvList.Panel.Color=Colors.Black
	Table = scvList.Panel
	Table.Color = LineColor
	If Activity.Height > Activity.Width Then
		pnlScrollView.AddView(btnExport, 0%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnClose, 40%x, 88%y, 40%x, 12%y)
		pnlScrollView.AddView(btnHelp,  80%x, 88%y, 20%x, 12%y)
		pnlScrollView.AddView(scvList,   0%x, RowHeight * 1.5, 100%x, 86%y - (RowHeight * 1.5))
	Else
		pnlScrollView.AddView(btnExport, 0%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnClose,  40%x, 80%y, 40%x, 20%y)
		pnlScrollView.AddView(btnHelp,  80%x, 80%y, 20%x, 20%y)
		pnlScrollView.AddView(scvList,   0%x, RowHeight * 1.5, 100%x, 78%y - (RowHeight * 1.5))
	End If
	ColumnWidth(0) = ColLineWidth				' hides the first column
	ColumnWidth(1) = scvList.Width * .35		' sets the remaining column widths 1/2 screen width
	ColumnWidth(2) = scvList.Width * .65
	ColumnWidth(3) = ColLineWidth				' hides the fourth column - Expanded/Collapsed flag
	ColumnWidth(4) = ColLineWidth				' hides the fifth column - Number fo child rows
	For i=0 To NumberOfColumns-1
		ColumnWidth_1(i) = ColumnWidth(i)-ColLineWidth	
	Next
	SelectedRow = -1
	SelectedItems.Initialize
	
	LoadWorkoutLogFromDB(CurrSortCol)

	Main.bmpAndroid.Initialize(File.DirAssets, "running_48x48.png")
	EOLChar = Chr(13) & Chr(10)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnClose_Click

	Activity.Finish
	StartActivity(Main)

End Sub

Sub btnExport_Click		' Export Workout Log and email to user

	Dim CSVList As List
	Dim CSVLine(5) As String
	Dim su As StringUtils
	Dim Message As Email
	
	' Add column headings
	CSVList.Initialize	
	CSVLine(0) = "Workout Date"
	CSVLine(1) = "Workout Name"
	CSVLine(2) = "Exercise"
	CSVLine(3) = "Reps per Set"
	CSVLine(4) = "Sets"
	CSVList.Add(CSVLine)
	
	' Get workout details from DB
	SQLStmt = "Select T1.WoLID, T1.WorkoutDate, T2.WorkoutName, T3.ExID, T3.ExPerRep, T3.Reps, T4.Exercise"
	SQLStmt = SQLStmt & " FROM WOLogH T1, WOTemplateH T2, WOLogD T3, Exercises T4"
	SQLStmt = SQLStmt & " WHERE T1.WoTID = T2.WoTID AND T1.WoLID = T3.WoLID AND T3.ExID = T4.ExID" 
	SQLStmt = SQLStmt & " ORDER BY T1.WorkoutDate"
	Cursor1 = Main.SQL1.ExecQuery(SQLStmt)
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		Dim CSVLine(5) As String
		CSVLine(0) = Cursor1.GetString("WorkoutDate")
		CSVLine(1) = Cursor1.GetString("WorkoutName")
		CSVLine(2) = Cursor1.GetString("Exercise")
		CSVLine(3) = Cursor1.GetString("ExPerRep")
		CSVLine(4) = Cursor1.GetString("Reps")
		CSVList.Add(CSVLine)
	Next
	
	If File.ExternalWritable Then
		Main.TargetDir = File.DirDefaultExternal
	Else
		Main.TargetDir = File.DirInternal
	End If
	If File.Exists(Main.TargetDir, "LMWExport.csv") = True Then
		File.Delete(Main.TargetDir, "LMWExport.csv")
	End If
	su.SaveCSV(Main.TargetDir, "LMWExport.csv", ",", CSVList)

	' Email exported file
    Message.To.Add(Main.EmailAddress)
	Message.Subject = "LogMyWorkout export attached"
    Message.body = "Please find attached CSV file containing details of all workouts that currently exist in the LogMyWorkout android app."
	Message.Attachments.Add(File.Combine(Main.TargetDir, "LMWExport.csv"))' attach a file to the email
    StartActivity(Message.GetIntent) 
	
End Sub

Sub Cell_Click			' Show Details of selected workout

	Dim rc As RowCol
	Dim l As Label
	Dim NoOfRows, Top, NoOfChildren, WoLID As Int
	Dim ParentChildFlag As Char
	
	l = Sender
	rc = l.Tag
	SelectRow(rc.Row)

	Top = GetView(rc.Row,0).Top
	WoLID = GetView(rc.Row, 0).Text
	ParentChildFlag = GetView(rc.Row,3).Text
	NoOfChildren = GetView(rc.Row, 4).Text

	If ParentChildFlag = "C" Then	' Row currently collapsed

		Dim v As View
		For j = 0 To Table.NumberOfViews - 1  
			v = Table.GetView(j)
			If v.Top  > Top Then
				v.Top = v.Top + (NoOfChildren * RowHeight)
			End If
		Next	
		Table.Height = Table.Height + (NoOfChildren * RowHeight)
		
		GetView(SelectedRow, 3).Text = "E"

		LoadExercisesFromDB(WoLID, Top)
			
	Else

		Dim v As View
		For j = 0 To Table.NumberOfViews - 1  
			If j < Table.NumberOfViews Then
				v = Table.GetView(j)
				If v.Tag = WoLID Then	' Only remove children belonging to current parent
					v.RemoveView
					j = j - 1	' reset counter as now 1 less view
				Else
					' Move all other parent rows up to fill gap left by deleted children
					If v.Top  > Top Then
						v.Top = v.Top - (NoOfChildren * RowHeight)
					End If
				End If
			End If
		Next	
		Table.Height = Table.Height - (NoOfChildren * RowHeight)

		GetView(SelectedRow, 3).Text = "C"

	End If
	
End Sub

Sub Cell_LongClick		' Delete current row

	Dim rc As RowCol
	Dim l As Label
	
	l = Sender
	rc = l.Tag

	' Confirm user wnats to delete row
	rVal = Msgbox2("Are you sure you want to delete the current row?", "Delete Workout Log", "Yes", "No", "", Main.bmpAndroid)

	' Update Database (DELETE)
	If rVal = DialogResponse.POSITIVE Then
		SQLStmt = "DELETE From WOLogH WHERE WoLID = " & GetView(rc.Row, 0).Text
		Main.SQL1.ExecNonQuery(SQLStmt)
		SQLStmt = "DELETE From WOLogD WHERE WoLID = " & GetView(rc.Row, 0).Text
		Main.SQL1.ExecNonQuery(SQLStmt)
		ClearAll
		LoadWorkoutLogFromDB(2)
	End If

End Sub
Sub Header_Click		' Re-sort Grid

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	ClearAll
	LoadWorkoutLogFromDB(col)

End Sub

Sub Header_LongClick	' Used to display column sensitive help

	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag

	' Display Help for Column
	Select col
		Case 1 
			HelpText = "This column contains the date that the workout was completed." 
			Msgbox2(HelpText, "Help: Workout Date", "OK", "", "", Main.bmpAndroid)
		Case 2 
			HelpText = "This column contains the name of the completed workout."
			Msgbox2(HelpText, "Help: Workout Name", "OK", "", "", Main.bmpAndroid)
	End Select
	
End Sub

Sub SelectRow(Row As Int)

	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = Colors.Black
		Next
	End If
	SelectedRow = Row
	For col = 0 To NumberOfColumns - 1
		GetView(Row, col).Color = SelectedRowColor
	Next

End Sub

Sub GetView(Row As Int, Col As Int) As Label

' Returns the label in the specific cell
	Dim l As Label
	l = Table.GetView(Row * NumberOfColumns + Col)
	Return l
	
End Sub

Sub LoadWorkoutLogFromDB(SortCol As Int)

	Dim i, rCount As Int
	Dim DateTick As Long

	If SortCol = 1 Then
		If CurrSortCol = 1 Then
			If CurrSortSeq = "D" Then
				Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T1.WorkoutDate")
				CurrSortSeq = "A"
			Else
				Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T1.WorkoutDate Desc")
				CurrSortSeq = "D"
			End If
		Else
			Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T1.WorkoutDate")
			CurrSortCol = 2
			CurrSortSeq = "A"
		End If
	Else
		If CurrSortCol = 2 Then
			If CurrSortSeq = "D" Then
				Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T2.WorkoutName")
				CurrSortSeq = "A"
			Else
				Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T2.WorkoutName Desc")
				CurrSortSeq = "D"
			End If
		Else
			Cursor1 = Main.SQL1.ExecQuery("SELECT T1.WoLID, T1.WorkoutDate, T2.WorkoutName FROM WOLogH T1, WOTemplateH T2 WHERE T1.WoTID = T2.WoTID ORDER By T2.WorkoutName")
			CurrSortCol = 1
			CurrSortSeq = "A"
		End If
	End If 
	CurrSortCol = SortCol

	Dim row(NumberOfColumns) As String
	row(0)="ExID"
	If SortCol = 1 Then 
		If CurrSortSeq = "A" Then
			row(1)="Date  >>"
		Else
			row(1)="Date  <<"
		End If
		row(2)="Workout Name"
	Else
		row(1)="Date"
		If CurrSortSeq = "A" Then
			row(2)="Workout Name  >>"
		Else
			row(2)="Workout Name  <<"
		End If
	End If
	SetHeader(row)
	
	For i = 0 To Cursor1.RowCount - 1
		
		Dim row(NumberOfColumns) As String
		
		Cursor1.Position = i
		
		row(0) = Cursor1.GetString("WoLID")
		
		DateTime.DateFormat = "yyyyMMdd"
		DateTick = DateTime.DateParse(Cursor1.GetString("WorkoutDate"))
		Select Case Main.DateFormat
			Case "MDY"		: DateTime.DateFormat = "MM/dd/yyyy"
			Case "DMY"		: DateTime.DateFormat = "dd/MM/yyyy"
			Case "YMD"		: DateTime.DateFormat = "yyyy/MM/dd"
			Case Else		: DateTime.DateFormat = "MM/dd/yyyy"
		End Select
		row(1) = DateTime.Date(DateTick)
		'row(1) = Cursor1.GetString("WorkoutDate")
		
		row(2) = Cursor1.GetString("WorkoutName")
		
		row(3) = "C"	' Start off collapsed
		
		' Determine how many exercises for this workout and store for use when expanding workout
		SQLStmt = "SELECT COUNT(*) from WOLogD WHERE WoLID = " & Cursor1.GetString("WoLID")
		rCount = Main.SQL1.ExecQuerySingleResult(SQLStmt)
		row(4) = rCount	 
		
		AddRow(row)
	Next
	Cursor1.Close
	
End Sub

Sub LoadExercisesFromDB(WoLID As Int, Top As Int)

	Dim i, rCount, LastRow As Int

	SQLStmt = "SELECT T2.Exercise, T1.ExPerRep, T1.Reps FROM WOLogD T1, Exercises T2 WHERE T1.WoLID = " & WoLID & " AND T1.ExID = T2.ExID ORDER By T2.Exercise"
	Cursor1 = Main.SQL1.ExecQuery(SQLStmt)
	Top = Top + RowHeight
	
	LastRow = Cursor1.RowCount - 1
	For i = 0 To Cursor1.RowCount - 1

		Cursor1.Position = i

		' Slow down load to make it look sexy
		Dim now As Long
    	now=DateTime.now
    	Do Until (DateTime.now > now + 20)
      		DoEvents
    	Loop

		' Blank panel to clear row
		Dim l As Label
		l.Initialize("child")
		l.Tag = WoLID
		l.Color = Colors.Black
		If i <> LastRow Then
			Table.AddView(l, 0%x, Top + (i * RowHeight), 100%x, RowHeight)
		Else
			Table.AddView(l, 0%x, Top + (i * RowHeight), 100%x, RowHeight - 1)
		End If

		Dim l As Label
		l.Initialize("child")
		l.Text = Cursor1.GetString("Exercise")
		l.Tag = WoLID
		l.Gravity = Gravity.CENTER_VERTICAL
		l.TextSize = 14
		l.TextColor = Colors.Green
		l.Color = Colors.Black
		If i <> LastRow Then
			Table.AddView(l, 3%x, Top + (i * RowHeight), 35%x, RowHeight)
		Else
			Table.AddView(l, 3%x, Top + (i * RowHeight), 35%x, RowHeight - 1)
		End If

		Dim l As Label
		l.Initialize("child")
		l.Text = Cursor1.GetString("ExPerRep")
		l.Tag = WoLID
		l.Gravity = Gravity.CENTER_VERTICAL
		l.TextSize = 14
		l.TextColor = Colors.Green
		l.Color = Colors.Black
		If i <> LastRow Then
			Table.AddView(l, 42%x, Top + (i * RowHeight), 25%x, RowHeight)
		Else
			Table.AddView(l, 42%x, Top + (i * RowHeight), 25%x, RowHeight - 1)
		End If
	
		Dim l As Label
		l.Initialize("child")
		l.Text = Cursor1.GetString("Reps")
		l.Tag = WoLID
		l.Gravity = Gravity.CENTER_VERTICAL
		l.TextSize = 14
		l.TextColor = Colors.Green
		l.Color = Colors.Black
		If i <> LastRow Then
			Table.AddView(l, 85%x, Top + (i * RowHeight), 25%x, RowHeight)
		Else
			Table.AddView(l, 85%x, Top + (i * RowHeight), 25%x, RowHeight - 1)
		End If

	Next
	Cursor1.Close
	
End Sub

Sub AddRow(Values() As String)

' Adds a row to the table
	Dim ColWidth As Int
	
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	Dim lastRow As Int
	lastRow = NumberOfRows
	ColWidth=0

	For i = 0 To NumberOfColumns - 1
 		Dim l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Gravity.CENTER_VERTICAL
		l.TextSize = 16
		l.TextColor = Colors.White
		l.Color = Colors.Black
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = lastRow
		l.Tag = rc
		Table.AddView(l, ColWidth, RowHeight * lastRow, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next

	Table.Height = NumberOfRows * RowHeight + 2
	
End Sub

Sub SetHeader(Values() As String)

	Dim ColWidth As Int

	Header.Initialize("")
	Line.Initialize("")
	Line.Color = Colors.Gray
	ColWidth=0
	Log("Head")
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = Values(i)
		l.Gravity = Gravity.CENTER_VERTICAL
		l.TextSize = 18
		l.Color = Colors.RGB(0,0,0)
		l.TextColor = Colors.RGB(255,165,0)
		l.Tag = i
		Header.AddView(l, ColWidth, 0, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next
	
	' Primary Row Headers retrieved from arrays - second line done manually!!
	Dim l As Label
	l.Initialize("header")
	l.Text = "Exercise"
	l.Tag = 1	' Do this to set column to Workout Date if user clicks below but still in header
	l.Gravity = Gravity.CENTER_VERTICAL
	l.TextSize = 14 
	l.Color = Colors.Black
	l.TextColor = Colors.Green ' Colors.RGB(255,165,0)
	Header.AddView(l, 3%x, RowHeight * .8, 35%x, RowHeight * .5)

	Dim l As Label
	l.Initialize("header")
	l.Text = "Reps/Set"
	l.Tag = 2	' Do this to set column to Workout Date if user clicks below but still in header
	l.Gravity = Gravity.CENTER_VERTICAL
	l.TextSize = 14 
	l.Color = Colors.Black
	l.TextColor = Colors.Green ' Colors.RGB(255,165,0)
	Header.AddView(l, 42%x, RowHeight * .8, 25%x, RowHeight * .5)
	
	Dim l As Label
	l.Initialize("header")
	l.Text = "Sets"
	l.Tag = 2	' Do this to set column to Workout Date if user clicks below but still in header
	l.Gravity = Gravity.CENTER_VERTICAL
	l.TextSize = 14 
	l.Color = Colors.Black
	l.TextColor = Colors.Green ' Colors.RGB(255,165,0)
	Header.AddView(l, 82%x, RowHeight * .8, 20%x, RowHeight * .5)

	pnlScrollView.AddView(Header, scvList.Left, scvList.Top - (RowHeight * 1.5), scvList.Width, RowHeight * 1.5)
	
	pnlScrollView.AddView(Line, scvList.Left, scvList.Top - 1dip, scvList.Width, 1%y)
	
End Sub

Sub ClearAll

	' Clears the table
	For i = Table.NumberOfViews -1 To 0 Step -1
		Table.RemoveViewAt(i)
	Next
	Table.Height = 0
	SelectedItems.Clear

End Sub

Sub NumberOfRows As Int

	Return Table.NumberOfViews / NumberOfColumns
	
End Sub

Sub btnHelp_Click		' Form level Help

	HelpText = "Use this screen to view all completed workouts." & EOLChar & EOLChar
	HelpText = HelpText & "Tasks for this screen:" & EOLChar
	HelpText = HelpText & "- Short press a workout to view workout details." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Export to email a CSV file with all workout details to a specified email address." & EOLChar & EOLChar
	HelpText = HelpText & "- Short Press a column heading to resequence the grid by that column. The sequence will "
	HelpText = HelpText & " toggle between ascending and descending sequence if pressed twice." & EOLChar & EOLChar
	HelpText = HelpText & "- Long Press a column heading to get additional help for that column." & EOLChar & EOLChar
	HelpText = HelpText & "- Press Close to exit the View Workouts screen and return to the Main screen."

	Msgbox2(HelpText, "Help: View Workouts", "OK", "", "", Main.bmpAndroid)
	
End Sub
